<?php
namespace CrazyElements;

use CrazyElements\Core\Responsive\Responsive;

use CrazyElements\PrestaHelper; 

if ( ! defined( '_PS_VERSION_' ) ) {
	exit; // Exit if accessed directly.
}
$langs    = PrestaHelper::EditorAlternateUrl(\Context::getContext());
$current_lang_url = $langs['current_lang_url'];
$current_lang_id = $langs['current_lang_id'];
unset($langs['current_lang_url']);
unset($langs['current_lang_id']);
$settingurl    = PrestaHelper::get_setting_page_url();

?>
<script type="text/template" id="tmpl-elementor-panel">
    <div id="elementor-mode-switcher"></div>
	<header id="elementor-panel-header-wrapper"></header>
	<main id="elementor-panel-content-wrapper"></main>
	<footer id="elementor-panel-footer">
		<div class="elementor-panel-container">
		</div>
	</footer>
</script>

<script type="text/template" id="tmpl-elementor-panel-menu">
    <div id="elementor-panel-page-menu-content"></div>
</script>

<script type="text/template" id="tmpl-elementor-panel-menu-group">
    <div class="elementor-panel-menu-group-title">{{{ title }}}</div>
	<div class="elementor-panel-menu-items"></div>
</script>

<script type="text/template" id="tmpl-elementor-panel-menu-item">
    <div class="elementor-panel-menu-item-icon">
		<i class="{{ icon }}"></i>
	</div>
	<# if ( 'undefined' === typeof type || 'link' !== type ) { #>
		<div class="elementor-panel-menu-item-title">{{{ title }}}</div>
	<# } else {
		let target = ( 'undefined' !== typeof newTab && newTab ) ? '_blank' : '_self';
	#>
		<a href="{{ link }}" target="{{ target }}"><div class="elementor-panel-menu-item-title">{{{ title }}}</div></a>
	<# } #>
</script>

<script type="text/template" id="tmpl-elementor-panel-header">
    <div id="elementor-panel-header-menu-button" class="elementor-header-button">
		<i class="elementor-icon ceicon-menu-bar tooltip-target" aria-hidden="true" data-tooltip="<?php PrestaHelper::esc_attr_e( 'Menu', 'elementor' ); ?>"></i>
		<span class="elementor-screen-only"><?php echo PrestaHelper::__( 'Menu', 'elementor' ); ?></span>
	</div>
	<div id="elementor-panel-header-title"></div>
	<div id="elementor-panel-header-add-button" class="elementor-header-button">
		<i class="elementor-icon ceicon-apps tooltip-target" aria-hidden="true" data-tooltip="<?php PrestaHelper::esc_attr_e( 'Widgets Panel', 'elementor' ); ?>"></i>
		<span class="elementor-screen-only"><?php echo PrestaHelper::__( 'Widgets Panel', 'elementor' ); ?></span>
	</div>
</script>

<script type="text/template" id="tmpl-elementor-panel-footer-content">
    <div id="elementor-panel-footer-settings" class="elementor-panel-footer-tool elementor-leave-open tooltip-target" data-tooltip="<?php PrestaHelper::esc_attr_e( 'Settings', 'elementor' ); ?>">
		<i class="ceicon-cog" aria-hidden="true"></i>
		<span class="elementor-screen-only"><?php printf( PrestaHelper::__( '%s Settings', 'elementor' ), 'lets_have_a_look'); ?></span>
	</div>
	<div id="elementor-panel-footer-lang" class="elementor-panel-footer-tool elementor-toggle-state">
		<i class="ceicon-font-awesome tooltip-target" aria-hidden="true" data-tooltip="<?php PrestaHelper::esc_attr_e( 'Language', 'elementor' ); ?>"></i>
		<span class="elementor-screen-only">
			<?php echo PrestaHelper::__( 'Language', 'elementor' ); ?>
		</span>
		<div class="elementor-panel-footer-sub-menu-wrapper">
			<div class="elementor-panel-footer-sub-menu">
				<?php 
					foreach($langs as $k => $lang){
							if($lang['lang_id'] == $current_lang_id){ ?>
							<div class="elementor-panel-footer-sub-menu-item active elementor-disabled" data-device-mode="desktop">
								<span class="elementor-title">
									<img src="<?php echo $lang['thumb']; ?>" alt="<?php echo $lang['iso']; ?>" class="mr-10" width="16" height="11">
									<?php echo $lang['name']; ?>
								</span>
								<span class="elementor-description">
									<i class="ceicon-check" aria-hidden="true"></i>
									Current
								</span>
							</div>
						<?php }else{ ?>
							<div class="elementor-panel-footer-sub-menu-item" data-device-mode="desktop">
								<a rel="noreferrer" href="<?php echo $lang['url']; ?>">
									<span class="elementor-title">
										<img src="<?php echo $lang['thumb']; ?>" alt="<?php echo $lang['iso']; ?>" class="mr-10" width="16" height="11">
										<?php echo $lang['name']; ?>
									</span>
								</a>
								<span class="crazy-lang-content-importer elementor-description" data-langid="<?php echo $lang['lang_id']; ?>">
									<i class="ceicon-file-download" aria-hidden="true"></i>
									<?php echo "Import Content"; ?>
								</span>
							</div>
						<?php } 
					}
				?>
			</div>
		</div>
	</div>
	<div id="elementor-panel-footer-navigator" class="elementor-panel-footer-tool tooltip-target" data-tooltip="<?php PrestaHelper::esc_attr_e( 'Navigator', 'elementor' ); ?>">
		<i class="ceicon-navigator" aria-hidden="true"></i>
		<span class="elementor-screen-only"><?php echo PrestaHelper::__( 'Navigator', 'elementor' ); ?></span>
	</div>
	<div id="elementor-panel-footer-history" class="elementor-panel-footer-tool elementor-leave-open tooltip-target elementor-toggle-state" data-tooltip="<?php PrestaHelper::esc_attr_e( 'History', 'elementor' ); ?>">
		<i class="ceicon-history" aria-hidden="true"></i>
		<span class="elementor-screen-only"><?php echo PrestaHelper::__( 'History', 'elementor' ); ?></span>
	</div>
	<div id="elementor-panel-footer-responsive" class="elementor-panel-footer-tool elementor-toggle-state">
		<i class="ceicon-device-desktop tooltip-target" aria-hidden="true" data-tooltip="<?php PrestaHelper::esc_attr_e( 'Responsive Mode', 'elementor' ); ?>"></i>
		<span class="elementor-screen-only">
			<?php echo PrestaHelper::__( 'Responsive Mode', 'elementor' ); ?>
		</span>
		<div class="elementor-panel-footer-sub-menu-wrapper">
			<div class="elementor-panel-footer-sub-menu">
				<div class="elementor-panel-footer-sub-menu-item" data-device-mode="desktop">
					<i class="elementor-icon ceicon-device-desktop" aria-hidden="true"></i>
					<span class="elementor-title"><?php echo PrestaHelper::__( 'Desktop', 'elementor' ); ?></span>
					<span class="elementor-description"><?php echo PrestaHelper::__( 'Default Preview', 'elementor' ); ?></span>
				</div>
				<div class="elementor-panel-footer-sub-menu-item" data-device-mode="tablet">
					<i class="elementor-icon ceicon-device-tablet" aria-hidden="true"></i>
					<span class="elementor-title"><?php echo PrestaHelper::__( 'Tablet', 'elementor' ); ?></span>
					<?php $breakpoints = Responsive::get_breakpoints(); ?>
					<span class="elementor-description"><?php echo sprintf( PrestaHelper::__( 'Preview for %s', 'elementor' ), $breakpoints['md'] . 'px' ); ?></span>
				</div>
				<div class="elementor-panel-footer-sub-menu-item" data-device-mode="mobile">
					<i class="elementor-icon ceicon-device-mobile" aria-hidden="true"></i>
					<span class="elementor-title"><?php echo PrestaHelper::__( 'Mobile', 'elementor' ); ?></span>
					<span class="elementor-description"><?php echo sprintf( PrestaHelper::__( 'Preview for %s', 'elementor' ), '360px' ); ?></span>
				</div>
			</div>
		</div>
	</div>
	<div id="elementor-panel-footer-saver-preview" class="elementor-panel-footer-tool tooltip-target" data-tooltip="<?php PrestaHelper::esc_attr_e( 'Preview Changes', 'elementor' ); ?>">
		<span id="elementor-panel-footer-saver-preview-label">
			<i class="ceicon-eye" aria-hidden="true"></i>
			<span class="elementor-screen-only"><?php echo PrestaHelper::__( 'Preview Changes', 'elementor' ); ?></span>
		</span>
	</div>
	<div id="elementor-panel-footer-saver-publish" class="elementor-panel-footer-tool">
		<button id="elementor-panel-saver-button-publish" class="elementor-button elementor-button-success elementor-disabled">
			<span class="elementor-state-icon">
				<i class="ceicon-loading ceicon-animation-spin" aria-hidden="true"></i>
			</span>
			<span id="elementor-panel-saver-button-publish-label">
				<?php echo PrestaHelper::__( 'Publish', 'elementor' ); ?>
			</span>
		</button>
	</div>
	<div id="elementor-panel-footer-saver-options" class="elementor-panel-footer-tool elementor-toggle-state">
		<button id="elementor-panel-saver-button-save-options" class="elementor-button elementor-button-success tooltip-target elementor-disabled" data-tooltip="<?php PrestaHelper::esc_attr_e( 'Save Options', 'elementor' ); ?>">
			<i class="ceicon-caret-up" aria-hidden="true"></i>
			<span class="elementor-screen-only"><?php echo PrestaHelper::__( 'Save Options', 'elementor' ); ?></span>
		</button>
		<div class="elementor-panel-footer-sub-menu-wrapper">
			<p class="elementor-last-edited-wrapper">
				<span class="elementor-state-icon">
					<i class="ceicon-loading ceicon-animation-spin" aria-hidden="true"></i>
				</span>
				<span class="elementor-last-edited">
					{{{ elementor.config.document.last_edited }}}
				</span>
			</p>
			<div class="elementor-panel-footer-sub-menu">
				<div id="elementor-panel-footer-sub-menu-item-save-draft" class="elementor-panel-footer-sub-menu-item elementor-disabled">
					<i class="elementor-icon ceicon-save" aria-hidden="true"></i>
					<span class="elementor-title"><?php echo PrestaHelper::__( 'Save Draft', 'elementor' ); ?></span>
				</div>
				<div id="elementor-panel-footer-sub-menu-item-save-template" class="elementor-panel-footer-sub-menu-item">
					<i class="elementor-icon ceicon-folder" aria-hidden="true"></i>
					<span class="elementor-title"><?php echo PrestaHelper::__( 'Save as Template', 'elementor' ); ?></span>
				</div>
			</div>
		</div>
	</div>
</script>

<script type="text/template" id="tmpl-elementor-mode-switcher-content">
    <input id="elementor-mode-switcher-preview-input" type="checkbox">
	<label for="elementor-mode-switcher-preview-input" id="elementor-mode-switcher-preview">
		<i class="ceicon" aria-hidden="true" title="<?php PrestaHelper::esc_attr_e( 'Hide Panel', 'elementor' ); ?>"></i>
		<span class="elementor-screen-only"><?php echo PrestaHelper::__( 'Hide Panel', 'elementor' ); ?></span>
	</label>
</script>

<script type="text/template" id="tmpl-editor-content">
    <div class="elementor-panel-navigation">
		<# _.each( elementData.tabs_controls, function( tabTitle, tabSlug ) {
			if ( 'content' !== tabSlug && ! elementor.userCan( 'design' ) ) {
			return;
		}
			#>
			<div class="elementor-panel-navigation-tab elementor-tab-control-{{ tabSlug }}" data-tab="{{ tabSlug }}">
				<a href="#">{{{ tabTitle }}}</a>
			</div>
		<# } ); #>
	</div>
	<# if ( elementData.reload_preview ) { #>
		<div class="elementor-update-preview">
			<div class="elementor-update-preview-title"><?php echo PrestaHelper::__( 'Update changes to page', 'elementor' ); ?></div>
			<div class="elementor-update-preview-button-wrapper">
				<button class="elementor-update-preview-button elementor-button elementor-button-success"><?php echo PrestaHelper::__( 'Apply', 'elementor' ); ?></button>
			</div>
		</div>
	<# } #>
	<div id="elementor-controls"></div>
	<# if ( elementData.help_url ) { #>
		<div id="elementor-panel__editor__help">
			<a id="elementor-panel__editor__help__link" href="{{ elementData.help_url }}" target="_blank">
				<?php echo PrestaHelper::__( 'Need Help', 'elementor' ); ?>
				<i class="ceicon-help-o"></i>
			</a>
		</div>
	<# } #>
</script>

<script type="text/template" id="tmpl-elementor-panel-schemes-disabled">
    <i class="elementor-nerd-box-icon ceicon-nerd" aria-hidden="true"></i>
	<div class="elementor-nerd-box-title">{{{ '<?php echo PrestaHelper::__( '%s are disabled', 'elementor' ); ?>'.replace( '%s', disabledTitle ) }}}</div>
	<div class="elementor-nerd-box-message"><?php printf( PrestaHelper::__( 'You can enable it from the <a href="%s" target="_blank">Elementor settings page</a>.', 'elementor' ), Settings::get_url() ); ?></div>
</script>

<script type="text/template" id="tmpl-elementor-panel-scheme-color-item">
    <div class="elementor-panel-scheme-color-input-wrapper">
		<input type="text" class="elementor-panel-scheme-color-value" value="{{ value }}" data-alpha="true" />
	</div>
	<div class="elementor-panel-scheme-color-title">{{{ title }}}</div>
</script>

<script type="text/template" id="tmpl-elementor-panel-scheme-typography-item">
    <div class="elementor-panel-heading">
		<div class="elementor-panel-heading-toggle">
			<i class="ceicon" aria-hidden="true"></i>
		</div>
		<div class="elementor-panel-heading-title">{{{ title }}}</div>
	</div>
	<div class="elementor-panel-scheme-typography-items elementor-panel-box-content">
		<?php
		$scheme_fields_keys = Group_Control_Typography::get_scheme_fields_keys();

		$typography_group = Plugin::$instance->controls_manager->get_control_groups( 'typography' );
		$typography_fields = $typography_group->get_fields();

		$scheme_fields = array_intersect_key( $typography_fields, array_flip( $scheme_fields_keys ) );

		foreach ( $scheme_fields as $option_name => $option ) :
			?>
			<div class="elementor-panel-scheme-typography-item">
				<div class="elementor-panel-scheme-item-title elementor-control-title"><?php echo $option['label']; ?></div>
				<div class="elementor-panel-scheme-typography-item-value">
					<?php if ( 'select' === $option['type'] ) : ?>
						<select name="<?php echo PrestaHelper::esc_attr( $option_name ); ?>" class="elementor-panel-scheme-typography-item-field">
							<?php foreach ( $option['options'] as $field_key => $field_value ) : ?>
								<option value="<?php echo PrestaHelper::esc_attr( $field_key ); ?>"><?php echo $field_value; ?></option>
							<?php endforeach; ?>
						</select>
					<?php elseif ( 'font' === $option['type'] ) : ?>
						<select name="<?php echo PrestaHelper::esc_attr( $option_name ); ?>" class="elementor-panel-scheme-typography-item-field">
							<option value=""><?php echo PrestaHelper::__( 'Default', 'elementor' ); ?></option>
							<?php foreach ( Fonts::get_font_groups() as $group_type => $group_label ) : ?>
								<optgroup label="<?php echo PrestaHelper::esc_attr( $group_label ); ?>">
									<?php foreach ( Fonts::get_fonts_by_groups( [ $group_type ] ) as $font_title => $font_type ) : ?>
										<option value="<?php echo PrestaHelper::esc_attr( $font_title ); ?>"><?php echo $font_title; ?></option>
									<?php endforeach; ?>
								</optgroup>
							<?php endforeach; ?>
						</select>
					<?php elseif ( 'text' === $option['type'] ) : ?>
						<input name="<?php echo PrestaHelper::esc_attr( $option_name ); ?>" class="elementor-panel-scheme-typography-item-field" />
					<?php endif; ?>
				</div>
			</div>
		<?php endforeach; ?>
	</div>
</script>

<script type="text/template" id="tmpl-elementor-control-responsive-switchers">
    <div class="elementor-control-responsive-switchers">
		<#
			var devices = responsive.devices || [ 'desktop', 'tablet', 'mobile' ];

			_.each( devices, function( device ) { #>
				<a class="elementor-responsive-switcher elementor-responsive-switcher-{{ device }}" data-device="{{ device }}">
					<i class="ceicon-device-{{ device }}"></i>
				</a>
			<# } );
		#>
	</div>
</script>

<script type="text/template" id="tmpl-elementor-control-dynamic-switcher">
    <div class="elementor-control-dynamic-switcher-wrapper">
		<div class="elementor-control-dynamic-switcher">
			<?php echo PrestaHelper::__( 'Dynamic', 'elementor' ); ?>
			<i class="ceicon-database"></i>
		</div>
	</div>
</script>

<script type="text/template" id="tmpl-elementor-control-dynamic-cover">
    <div class="elementor-dynamic-cover__settings">
		<i class="ceicon-{{ hasSettings ? 'wrench' : 'database' }}"></i>
	</div>
	<div class="elementor-dynamic-cover__title" title="{{{ title + ' ' + content }}}">{{{ title + ' ' + content }}}</div>
	<# if ( isRemovable ) { #>
		<div class="elementor-dynamic-cover__remove">
			<i class="ceicon-close-circle"></i>
		</div>
	<# } #>
</script>

<script type="text/template" id="tmpl-elementor-panel-page-settings">
    <div class="elementor-panel-navigation uuu">
		<# _.each( elementor.config.page_settings.tabs, function( tabTitle, tabSlug ) { #>
			<div class="elementor-panel-navigation-tab elementor-tab-control-{{ tabSlug }}" data-tab="{{ tabSlug }}">
				<a href="#">{{{ tabTitle }}}</a>
			</div>
			<# } ); #>
	</div>
	<div id="elementor-panel-page-settings-controls"></div>
</script>